package com.example.aplicativo;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.BitmapFactory;
import android.location.LocationManager;
import android.media.Ringtone;
import android.media.RingtoneManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.SystemClock;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.support.v4.app.NotificationCompat;
import android.util.Log;

import com.facebook.widget.ProfilePictureView;
import com.facebook.FacebookRequestError;
import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;
import com.facebook.model.GraphUser;
import com.parse.Parse;
import com.parse.ParseFacebookUtils;
import com.parse.ParseUser;

public class Painel_Principal extends Activity
{
	ArrayList<String> languageNames = new ArrayList<String> ();

	private Handler customHandler = new Handler();
	private String EnviaIdiomaUsuario;
	private String NomeUsuario = "";
	private String facebookId=null;
	private String cidade="";
	private String email="";
	
	public String MensagemNotificacao=" ";
	public String TituloNotificacao=" ";
	public String NomeNotificacao=" ";	
	public String titulo=" ";
	
	JSONObject language;
	JSONArray Idioma;
	
	private ProgressDialog progressDialog;
	private SeekBar SeekBarLimiteBusca;
	private int progresso = 1;	
	ProgressDialog dialog;
	
	private long timeInMilliseconds = 0L;
	private long timeSwapBuff = 0L;
	private long updatedTime = 0L;
	private long startTime = 0L;
	private int MinhaID=-1;
	
	private ProfilePictureView userProfilePictureView;
	private TextView userLocationView;
	private TextView userLanguageView;
	private TextView userEmailView;
	private TextView userNameView;
	private TextView TxTLimite;
	
	private Button logoutButton;
	private Button btMapa;
	int IDCHAT;
	int ID=7;
	
    @Override
    protected void onCreate(final Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.painel_principal);       
        inicializa();
    } 
    
    private void inicializa() 
    {   
    	progressDialog = ProgressDialog.show(Painel_Principal.this, "Aguarde..", "Carregando informaes...", true);
    	linkView();
    	FindViews();
	}  
    
    /*
     * Fazendo o ligamento dos TextView com a tela do painel_opo 
     */
    private void FindViews()
    {
    	userProfilePictureView = (ProfilePictureView) findViewById(R.id.userProfilePicture);
		userLocationView = (TextView) findViewById(R.id.painel_opcao_tv_Usu_Cidade);
		userLanguageView = (TextView) findViewById(R.id.painel_opcao_tv_idioma);
		userEmailView = (TextView) findViewById(R.id.painel_opcao_tv_Usu_Email);
		userNameView = (TextView) findViewById(R.id.painel_opcao_tv_Usu_Nome);
    }    
	
    private void linkView()
    {
    	btMapa = (Button) findViewById(R.id.painel_opcoes_btMapa);
    	btMapa.setOnClickListener(click_btMapa);
    	
    	SeekBarLimiteBusca = (SeekBar) findViewById(R.id.painel_opcoes_SeekBarLimiteBusca);
    	TxTLimite = (TextView) findViewById(R.id.painel_opcoes_TxtDistancia);
    	SeekBarLimiteBusca.setOnSeekBarChangeListener(Move_Cursor);
    	TxTLimite.setText("1 m");
    	
    	logoutButton = (Button) findViewById(R.id.logoutButton);
    	logoutButton.setOnClickListener(click_btFacebooLogout);
    	/*
   	 	Faz a verificao se o usuario ja logou no facebook utilizando o Aplicativo ou FACEBOOK.
   	 	caso ja tenha logado chama a makeMeRequeste, que sera utilizada para pegar as informaes do usuario
   	  	*/ 
    	if (VerificaConexao(Painel_Principal.this)) 
    	{
    		Parse.initialize(this, "281498018688207","d44888c855959b44d17378039cefb59f");
    		ParseFacebookUtils.initialize(getString(R.string.app_id));
        	Session session = ParseFacebookUtils.getSession();
    	
        	if (session != null && session.isOpened())
        	{
    			makeMeRequest();
    		}	
		}
    	else
    	{  
			progressDialog.dismiss();
			TelaSemInternet();
		} 
    }
    
	/*OnSeekBar*/
	OnSeekBarChangeListener Move_Cursor = new OnSeekBarChangeListener()
	{
		
		@Override
		public void onStopTrackingTouch(SeekBar seekBar)
		{
			TxTLimite.setText(progresso+" m");
			Toast.makeText(Painel_Principal.this,"Distncia atualizada:"+progresso+" m",Toast.LENGTH_SHORT).show();
		}
			
		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {

		}
		
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser)
		{
			progresso = progress * 10;
		}
	};
	
    /* onClick */
    OnClickListener click_btMapa = new OnClickListener()
    {
	
    	@Override
		public void onClick(View v) 
    	{
		
    		if (VerificaConexao(Painel_Principal.this))
    		{  
				VerificaGPS();
            }
    		else
    		{  
            	TelaSemInternet();  
            }  
		}
	};
	
	OnClickListener click_btFacebooLogout = new OnClickListener()
	{
		 /*
		  * Faz a verificao se existe conectividade no SmartPhone, caso tenha o usuario ira fazer logout
		  * Se no houver conexo, uma mensagem de erro sera apresentada
		  */
			@Override
			public void onClick(View v) 
			{
			
				if (VerificaConexao(Painel_Principal.this))
				{  
					onLogoutButtonClicked();
	            }
				else
				{  
	                mostraAlerta("Sem conexo com a internet.");  
	            }  
			}
	 };
	 
	/*
	* Faz a verificao se  a primeira vez do usuario no aplicativo ou se ele ja logou
	* Caso o usuario ja logou no aplicativo, ira apenas atualizar as informaes dele, Caso contrario
	* sera feito a chamada para o usuario logar no facebook
	*/
	@Override 
	public void onResume()
	{
		 super.onResume();
            ParseUser currentUser = ParseUser.getCurrentUser();
			if (currentUser != null)
			{
				//Verifique se o usurio est conectado e mostrar qualquer coisa do contedo em cache
				updateViewsWithProfileInfo();
			}
			else
			{
				//Se o usurio no estiver logado, v para a atividade, mostrando a viso de login.
				startLoginActivity();
			}
	}		
	
	 @Override
	public void onDestroy()
	 {
		super.onDestroy();
		finish();
	}
	
	@Override
	public void onPause()
	{
		super.onPause();
	}
	
	/*
	  * Faz a verificaco do GPS, caso esteja desabilitado sera apresentando uma mensagem informando,
	  * se estiver habilitado, ira passar alguns dados para a tela do mapa, no caso o limite que usuario
	  * que fazer sua busca, utilizando Bundle para estar passando essa informao, e faremos a chamada
	  * da tela Mostra_mapa
	  */
	public void VerificaGPS()
	{
		LocationManager service = (LocationManager) getSystemService(LOCATION_SERVICE);
		boolean enabled = service.isProviderEnabled(LocationManager.GPS_PROVIDER);
	
		if (enabled)
		{
        	Bundle extras = new Bundle();//enviar o limite para corte dos usuarios
			extras.putInt("limite", progresso);
			extras.putInt("MinhaID", MinhaID);
			extras.putString("nome", NomeUsuario);
			Intent MostraMap = new Intent(getApplicationContext(),Tela_com_Mapa.class);
			MostraMap.putExtras(extras);//envia o parametro
			startActivity(MostraMap);
        }
		else
		{
             mostraAlerta("GPS desabilitado.");
         }
	}
	
	/*
	 * Faz a verificaao se o SmartPhone est conectado a internet, caso esteja retorna verdadeiro, o usuario
	 * conseguira ter acesso a informaes do aplicativo, se no houver conexo uma mensagem de erro seja 
	 * apresentado ao usuario informando a falta de conectividade
	 */
	public boolean VerificaConexao(Context classe) 
	{  
        //Pego a conectividade do contexto passado como argumento  
        ConnectivityManager gerenciador = (ConnectivityManager) classe.getSystemService(Context.CONNECTIVITY_SERVICE);  
        //Crio a varivel informacao que recebe as informaes da Rede  
        NetworkInfo informacao = gerenciador.getActiveNetworkInfo();  
        //Se o objeto for nulo ou nao tem conectividade retorna false  
        
        if ((informacao != null) && (informacao.isConnectedOrConnecting()) && (informacao.isAvailable()))
        {  
        	return true; 
        }  
        return false;  
    }  
	
	/*
	 * Procedimento makeMeRequest
	 * Requesito ao Facebook as informaes de permisso, se as informaes forem validas
	 * Crio um objeto para estar armazendo as informaes enviadas que sero recebidas pelo formato JSON
	 * a variavel userProfile ira "pegar" todas as informaes que forem necessarias para aplicao,
	 * Por exemplo: Nome, IDFaceboko, email entre outras.
	 * Apos pegar todas as informaes salvo o em Background e chamo o procedimento updateViewsWithProfileInfo
	 * que ficara a cargo de estar adicionando essas informaes nas variaveis necessarias 
	 */
    private void makeMeRequest()
    {
		Request request = Request.newMeRequest(ParseFacebookUtils.getSession(),
				new Request.GraphUserCallback()
				{
					@Override
					public void onCompleted(GraphUser user, Response response)
					{
						if (user != null)
						{
							// Cria um objeto JSON para armazenar as informaes de perfil							 
							//String json = "";
							JSONObject userProfile = new JSONObject();
							try
							{
								//json = user.toString();
								// Preenche o JSON object
								userProfile.put("facebookId", user.getId());
								userProfile.put("name", user.getName());
								
								if (user.getLocation().getProperty("name") != null)
								{
									userProfile.put("location", (String) user.getLocation().getProperty("name"));
								}
								
								if (user.getProperty("gender") != null)
								{
									userProfile.put("gender",(String) user.getProperty("gender"));
								}
								
								if (user.getBirthday() != null)
								{
									userProfile.put("birthday",user.getBirthday());
								}
								
								if (user.getProperty("relationship_status") != null)
								{
									userProfile.put("relationship_status",(String) user.getProperty("relationship_status"));
								}
								
								if (user.getProperty("email") != null)
								{
									userProfile.put("email",(String) user.getProperty("email"));
								}
								/*
								 * Pego o idioma do usuario, crio uma Array e um JsonObject para estar recebendo 
								 * essas informaes
								 */
								if (user.getProperty("languages") != null)
								{
									// - Requer Permissao user_likes
									Idioma = (JSONArray)user.getProperty("languages");
								    
									if (Idioma.length() > 0)
								    {
								        
								    	for (int i=0; i < Idioma.length(); i++)
								        {
								            language = Idioma.optJSONObject(i);
								            languageNames.add(language.optString("name"));
								        }           
								        userLanguageView.append(String.format("%s", languageNames.toString()));
								    }
								}
								// Salva as informaes de perfil de usurio em uma propriedade de usurio
								ParseUser currentUser = ParseUser.getCurrentUser();
								currentUser.put("profile", userProfile);
								currentUser.saveInBackground();
								//Mostra as informacoes na tela
								updateViewsWithProfileInfo();
							}
							catch (JSONException e) 
							{
								Log.d(IntegracaoFacebook.TAG,"Erro ao analisar retornou os dados do usurio.");
							}
						}
						else 
							if (response.getError() != null) 
							{
								if ((response.getError().getCategory() == FacebookRequestError.Category.AUTHENTICATION_RETRY)
										|| (response.getError().getCategory() == FacebookRequestError.Category.AUTHENTICATION_REOPEN_SESSION)) {
									Log.d(IntegracaoFacebook.TAG,"A sesso do Facebook foi invalidada.");
									onLogoutButtonClicked();
								}
								else {
									Log.d(IntegracaoFacebook.TAG, "Algum outro erro: "+ response.getError().getErrorMessage());
								}
							}
					}
				});
		request.executeAsync();
	}
    
    /*
     * Faz a atualizao dos dados recebidos pelo MakeMeRequest e atribuo cada informao a sua variavel
     * correspondente
     */
	private void updateViewsWithProfileInfo()
	{
		ParseUser currentUser = ParseUser.getCurrentUser();
		
		if (currentUser.get("profile") != null)
		{
			JSONObject userProfile = currentUser.getJSONObject("profile");
		
			try
			{
				
				if (userProfile.getString("facebookId") != null)
				{
					facebookId = userProfile.get("facebookId").toString();
					userProfilePictureView.setProfileId(facebookId);
				}
				else
				{
					// Show the default, blank user profile picture
					userProfilePictureView.setProfileId(null);
				}
				
				if (userProfile.getString("name") != null) 
				{
					userNameView.setText(userProfile.getString("name"));
					NomeUsuario = userProfile.getString("name");
					
				}
				else
				{
					userNameView.setText("");
					NomeUsuario = userProfile.getString("");
				}
				
				if (userProfile.getString("location") != null)
				{
					userLocationView.setText(userProfile.getString("location"));
					cidade = userProfile.getString("location");
				}
				else
				{
					userLocationView.setText("");
					cidade = userProfile.getString("");
				}
				
				if (userProfile.getString("email") != null)
				{
					userEmailView.setText(userProfile.getString("email"));
					email = userProfile.getString("email");
				}
				else
				{
					userEmailView.setText("");
					email = userProfile.getString("");
				}				
				progressDialog.dismiss();
				/*
				 * Efetuo o cadastro do usuario no banco de dados online
				 */ 
				EnviaIdiomaUsuario = languageNames.toString();
				CadastraUsuario();
				Timer();
			} 
			catch (JSONException e) 
			{
				Log.d(IntegracaoFacebook.TAG,"Erro ao analisar os dados do usuario.");
			}
		}
	}
	
	/*
	 * a cada 20 segundos fico verificando no banco de dados se possui alguma nova mensagem
	 * caso possua uma notificao sera exibida ao usuario informando
	 */
	public void VerificaNovasMensagens()
	{
		AsyncTask<Void, Void, Void> task = new AsyncTask<Void, Void, Void>()
		{
		    public String Conteudo;
		    String data ="";
			
		    @Override
			protected Void doInBackground(Void... params) 
		    {
		    	BufferedReader reader=null;
		    
		    	try
		    	{ 
		    		URL url = new URL("http://www.brunodeandrade.com.br/luciano/notificacao.php?id_recv="+MinhaID);
		    		URLConnection conn = url.openConnection(); 
		    		conn.setDoOutput(true); 
		            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream()); 
		            wr.write( data ); 
		            wr.flush(); 
		            //Pego a resposta do servidor 
		            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		            StringBuilder sb = new StringBuilder();
		            String line = null;
			        
		            // escrevo a resposta do servidor
			        while((line = reader.readLine()) != null)
			        {
			        	// Acrescento a resposta do servidor em uma string
			            sb.append(line + "\n");
			        }
		            // Acrescento a resposta do servidor no Content string
		            Conteudo = sb.toString();
		    	}
		    	catch(Exception ex)
		    	{
		    		ex.getMessage();
		    	}
		    	finally
		    	{
		    		try
		    		{
		    			reader.close();
		            }
		    		catch(Exception ex) {	
		            }
		    	}
		        return null;
			}
		    
			@Override 
			protected void onPreExecute() 
			{ 
				super.onPreExecute(); 
			}
			
			@Override
			protected void onPostExecute(Void result)
			{
				super.onPostExecute(result);
				try 
				{
					/*
			    	 * Variavel global para verificao de notificaos com a tela de chat
			    	 */
					GlobalClass globalVariable = (GlobalClass) getApplicationContext();
					//Cria um novo JSONOBject com nome vindo da JSON string
			        JSONArray jsonResposta = new JSONArray(Conteudo);
					int TamanhoJsonArr = jsonResposta.length();
				
					for(int i = 0; i < TamanhoJsonArr; i++) 
					{
						JSONObject jsonObject = jsonResposta.getJSONObject(i);
						int ID = jsonObject.getInt("codigo_mensagem");
						IDCHAT = globalVariable.getGlobal();
					
						if(IDCHAT!=ID)
						{ 
							gerarNotificacao();	
						}
					}
			    }
				catch (JSONException e) 
				{
			    	e.printStackTrace();
			    }
			}
		};
		task.execute();
	}
	/*
	 * Procedimento que gera a notificao para usuario informando uma nova mensagem
	 * caso o usuario click na notificacao e tenha mais de uma notificacao a tela de Painel Mensagem sera aberta
	 * com as mensagem, caso contrario ira abrir o chat com a pessoas especifica
	 */
	public void gerarNotificacao()
	{	
		NotificationManager nm = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
		
		Intent intent = new Intent(getApplicationContext(), Painel_Mensagens.class);
		PendingIntent p = PendingIntent.getActivity(getApplicationContext(), 0, intent, 0);
		
		NotificationCompat.Builder builder = new NotificationCompat.Builder(this);
		builder.setTicker("Voc tem uma nova mensagem.");
		builder.setContentTitle("Nova Mensagem");
		builder.setContentText("Voc tem uma nova mensagem!");
		//builder.setContentText(MensagemNotificacao);
		//builder.setContentInfo("...");
		//builder.setSubText("10");
		builder.setSmallIcon(R.drawable.icone_notificacao_pequeno);
		builder.setLargeIcon(BitmapFactory.decodeResource(getResources(), R.drawable.icone_notificacao_pequeno));
		builder.setContentIntent(p);
		
		NotificationCompat.InboxStyle style = new NotificationCompat.InboxStyle();
		String [] descs = new String[]{"Click aqui para visualizar a mensagem."};
		
		for(int i = 0; i < descs.length; i++)
		{
			style.addLine(descs[i]);
		}
		
		builder.setStyle(style);
		Notification n = builder.build();
		n.vibrate = new long[]{150, 300, 150, 600};
		n.flags = Notification.FLAG_AUTO_CANCEL;
		nm.notify(R.drawable.ic_launcher, n);
		
		try
		{
			Uri som = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
			Ringtone toque = RingtoneManager.getRingtone(this, som);
			toque.play();
		}
		catch(Exception e){}
	}	
	
	/*
	* Efetuo o cadastro do usuario no banco de dados, para que possa utilizar a ID em novas janelas
	*/
	public void CadastraUsuario()
	{
		AsyncTask<Void, Void, Void> task = new AsyncTask<Void, Void, Void>()
		{
		    public String Conteudo="";
		    String dados ="";
			@SuppressLint("SimpleDateFormat")
			@Override
			protected Void doInBackground(Void... params)
			{
		    	BufferedReader reader=null;
		    	
		    	try
		    	{ 
		    		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		    		java.util.Date data = new java.util.Date();
		    		String AjustaData = String.valueOf(dateFormat.format(data));
		    		AjustaData=AjustaData.replace(" ","%20");
		    		
		    		NomeUsuario=NomeUsuario.replace(" ","%20");
		    		EnviaIdiomaUsuario=EnviaIdiomaUsuario.replace(" ","%20");
		    		// Define a URL que esta enviando os dados 
		    		URL url = new URL("http://www.brunodeandrade.com.br/luciano/luciano_get.php?nome="+NomeUsuario+"&idioma="+EnviaIdiomaUsuario+"&email="+email+"&cidade="+cidade+"&data="+AjustaData+"&status=0");
		    		System.out.println("http://www.brunodeandrade.com.br/luciano/luciano_get.php?nome="+NomeUsuario+"&idioma="+EnviaIdiomaUsuario+"&email="+email+"&cidade="+cidade+"&data="+AjustaData+"&status=0");
		    		URLConnection conn = url.openConnection(); 
		    		conn.setDoOutput(true); 
		            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream()); 
		            wr.write( dados ); 
		            wr.flush(); 
		            //Pego a resposta do servidor 
		            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		            StringBuilder sb = new StringBuilder();
		            String line = null;
			        // escrevo a resposta do servidor
			    
		            while((line = reader.readLine()) != null)
		            {
			        	// Acrescento a resposta do servidor em uma string
			            sb.append(line + "\n");
			        }
		            // Acrescento a resposta do servidor no Content string
		            Conteudo = sb.toString();
		    	}
		    	catch(Exception ex)
		    	{
		    		ex.getMessage();
		    	}
		    	finally
		    	{
		    		try
		    		{
		    			reader.close();
		            }
		    		catch(Exception ex) {
		            }
		    	} 
		        return null;
			}
			
			@Override 
			protected void onPreExecute() 
			{ 
				super.onPreExecute();
			}
			
			@Override
			protected void onPostExecute(Void result)
			{
				super.onPostExecute(result);
				try 
				{
					GlobalClass informacoesClasse = (GlobalClass) getApplicationContext();
					informacoesClasse.setMeuNomel(NomeUsuario);
					//Cria um novo JSONOBject com nome vindo da JSON string
			        JSONArray jsonResposta = new JSONArray(Conteudo);
					int TamanhoJsonArr = jsonResposta.length();
				
					for(int i = 0; i < TamanhoJsonArr; i++) 
					{
						JSONObject jsonObject = jsonResposta.getJSONObject(i);
						MinhaID = jsonObject.getInt("id");
						informacoesClasse.setMeuID(MinhaID);
					}
			    } 
				catch (JSONException e) 
				{
			    	e.printStackTrace();
			    }
			}
		};
		task.execute();
	}
	
	/*
	*Se o usuario precionar o boto logout esse procedimento sera solicitado
	*informo uma mensagem que esta finalizando sesso, e fao o logout do usuario
	*e chamo a tela inicial 
	*/
	private void onLogoutButtonClicked() 
	{
		//limpa a sessao para poder entrar com outro usuario, somente entrara com outro usuario se o Aplicativo
		//do facebook no esteja logado em nenhuma conta
		ParseFacebookUtils.getSession().closeAndClearTokenInformation();
        //log de saida do usuario
        ParseUser.logOut();
		// vai para tela de login
		startLoginActivity();
	}	
	
	private void Timer()
	{
		
		if (VerificaConexao(Painel_Principal.this)) 
		{             
			VerificaNovasMensagens();
        }
		else 
		{  
        	//TelaSemInternet();  
        }  
		
		startTime = SystemClock.uptimeMillis();
		customHandler.postDelayed(updateTimerThread, 0);
	}
	
	private Runnable updateTimerThread = new Runnable() 
	{

		public void run() 
		{
			timeInMilliseconds = SystemClock.uptimeMillis() - startTime;
			updatedTime = timeSwapBuff + timeInMilliseconds;
			int secs = (int) (updatedTime / 1000);
			//int mins = secs / 60;
			
			secs = secs % 60;
			//int milliseconds = (int) (updatedTime % 1000);
			customHandler.postDelayed(this, 0);
			//tempo para atualizar os dados
		
			if(secs==20)
			{
				timeSwapBuff += timeInMilliseconds;
				customHandler.removeCallbacks(updateTimerThread);
				startTime = 0L;			
				timeInMilliseconds = 0L;
				timeSwapBuff = 0L;
				updatedTime = 0L;
				Timer();
			}
		}
	};
	
	/*
	 * Procedimento para estar cancelando a Thread com o timer
	 */
	public void CancelaTimer()
	{
		timeSwapBuff += timeInMilliseconds;
		customHandler.removeCallbacks(updateTimerThread);
	}
	
	/*
	 * Procedimento para estar chamando a tela inicial do aplicativo caso o usuario tenha feito logout
	 */
	private void startLoginActivity() 
	{
		CancelaTimer();//predimento para desabilitar o timer
		Intent intent = new Intent(this, MainActivity.class);
		intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		startActivity(intent);
	}
	
	private void TelaSemInternet()
	{
		CancelaTimer();
		String opc="PainelPrincipal";
		Bundle extras = new Bundle();
		extras.putString("tela",opc);
		
		Intent TelaSemInternet = new Intent(getApplicationContext(), Tela_Sem_Internet.class);
		TelaSemInternet.putExtras(extras);
		startActivity(TelaSemInternet);
	}
	
	public void ToastMake(String Msg)
	{
			Toast.makeText(this,Msg,Toast.LENGTH_SHORT).show();
	}
	
	// Mostra a informao caso no tenha internet.  
    private void mostraAlerta(String mensagem) 
    {  
        AlertDialog.Builder informa = new AlertDialog.Builder(Painel_Principal.this);  
        informa.setTitle("Alerta!").setMessage(mensagem);  
        informa.setNeutralButton("Voltar", null).show();   
    }    
    /*
     * Evito que ao pressionar o boto voltar ele retorne para a tela inicial de login
     */ 
    public void onBackPressed() 
    {
        Intent intent = new Intent();
        intent.setAction(Intent.ACTION_MAIN);
        intent.addCategory(Intent.CATEGORY_HOME);
        startActivity(intent);
        return;
    }
    
    @Override
	public boolean onOptionsItemSelected(MenuItem item) 
	{
		int id=item.getItemId();
	
		if(id == R.id.painel_opcoes_deslogar)
		{
			onLogoutButtonClicked();
		}
		
		if(id == R.id.painel_opcoes_sobre)
		{
			Intent PainelSobre = new Intent(getApplicationContext(), Tela_sobre_Painel_Inicial.class);
			startActivity(PainelSobre);
		}
		
		if(id == R.id.painel_opcoes_chat)
		{
			Bundle extras = new Bundle();
			extras.putInt("MeuID",MinhaID);
			extras.putString("MeuNome",NomeUsuario);
			Intent PainelMensagens = new Intent(getApplicationContext(), Painel_Mensagens.class);
			PainelMensagens.putExtras(extras);//envia o parametro
			startActivity(PainelMensagens);
		}
		return super.onOptionsItemSelected(item);
	}
    
    @Override
	public boolean onCreateOptionsMenu(Menu menu) 
    {
    	// Inflate the menu; this adds items to the action bar if it is present.
    	getMenuInflater().inflate(R.menu.config_painel, menu);
    	return true;
	}
}
