package com.example.aplicativo;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;


import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.os.AsyncTask;
import android.util.Log;
/*
 * Envia a mensagem para o banco de dados
 */
public class Envia_Mensagem_Botao_Chat  extends AsyncTask<String, String, Void> 
{   
	InputStream inputStream = null;
	private int codigo_mensagem;
	private String nome_recv;
	private String mensagem;
    private String meu_nome;
    private int id_recv;
    private int id_send; 
    
    /*
     * Recebe os dados da outra classe e retira os espaos para estar enviando via Json
     * utilizo o replace para estar removendo os espaos e trocando por $
     */
	public Envia_Mensagem_Botao_Chat(int id_Meu, int id_Enviar,int codigo, String Msg, String Nome, String Nome_RECV) 
	{
		codigo_mensagem = codigo;
		id_recv = id_Enviar;
        id_send = id_Meu;
        meu_nome = Nome;
        meu_nome = meu_nome.replace(" ","%20");
        mensagem = Msg;
        mensagem = mensagem.replace(" ","%20");
        nome_recv = Nome_RECV;
        nome_recv = nome_recv.replace(" ", "%20");
	}
	
	//chama depois o Metodo onPreExecute
    public Void doInBackground(String... urls) 
    {
    	InputStream inputStream = null;
    	 try 
    	 {
             // 1. Criando HttpClient
             HttpClient httpclient = new DefaultHttpClient();
             HttpGet httpGet = new HttpGet("http://www.brunodeandrade.com.br/luciano/chat_get.php?id_send="+id_send+"&id_recv="+id_recv+"&mensagem="+mensagem+"&cod_msg="+codigo_mensagem+"&nome="+meu_nome+"&nome_recv="+nome_recv);
             
             httpGet.setHeader("Accept", "application/json");
             httpGet.setHeader("Content-Type", "application/json");
  
             // 8. executa a solicitao da url
             HttpResponse httpResponse = httpclient.execute(httpGet);
  
             // 9. recebe resposta do inputStream
             inputStream = httpResponse.getEntity().getContent();
  
             // 10. converte inputstream para string
             if(inputStream != null)
             {
				convertInputStreamToString(inputStream);
             }
			else {
			}
  
         } catch (Exception e) {
             Log.d("InputStream", e.getLocalizedMessage());
         }
    	return null;
    }
    public void onPostExecute(String result) {
    	
    }
	private static String convertInputStreamToString(InputStream inputStream) throws IOException 
	{
    	BufferedReader bufferedReader = new BufferedReader( new InputStreamReader(inputStream));
        String line = "";
        String result = "";
        while((line = bufferedReader.readLine()) != null){
            result += line;
        }
        inputStream.close();
        return result;
	}
}
     