package com.example.aplicativo;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.os.AsyncTask;
import android.util.Log;
/*
 * Classe responsavel para enviar minha latitude e longitude para o banco de dados
 */
public class Enviar_Meus_dados_banco_dados  extends AsyncTask<String, String, Void> 
{   
    
	InputStream inputStream = null;	
	private double latitude;
    private double longitude; 
    private int MinhaID;
    
    /*
     *Atualizo minhas coordenadas no banco de dados
     */
	public Enviar_Meus_dados_banco_dados(Double lat, Double lon, int ID ) 
	{
		latitude=lat;
		longitude=lon;
		MinhaID=ID;
	}
	
	//chama depois o Metodo onPreExecute
    public Void doInBackground(String... urls) 
    {
    	InputStream inputStream = null;
        
    	 try 
    	 {
             // 1. Criando HttpClient
             HttpClient httpclient = new DefaultHttpClient();
             HttpGet httpGet = new HttpGet("http://www.brunodeandrade.com.br/luciano/atualiza_co.php?id="+MinhaID+"&latitude="+latitude+"&longitude="+longitude);

             httpGet.setHeader("Accept", "application/json");
             httpGet.setHeader("Content-Type", "application/json");
  
             // 8. executa a solicitao da url
             HttpResponse httpResponse = httpclient.execute(httpGet);
  
             // 9. recebe resposta do inputStream
             inputStream = httpResponse.getEntity().getContent();
  
             // 10. converte inputstream para string
             if(inputStream != null)
				convertInputStreamToString(inputStream);
             
			else {
			}
  
         } 
    	 catch (Exception e) 
    	 {
             Log.d("InputStream", e.getLocalizedMessage());
         }
    	return null;
    }
    
    public void onPostExecute(String result) 
    {
    	
    }
	
    private static String convertInputStreamToString(InputStream inputStream) throws IOException 
	{
    	BufferedReader bufferedReader = new BufferedReader( new InputStreamReader(inputStream));
        String line = "";
        String result = "";
        
        while((line = bufferedReader.readLine()) != null)
        {
            result += line;
        }
        
        inputStream.close();
        return result;
	}
}
     